/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


var agentConfig = require ('./agentConfig');

var self = module.exports = {
    
    socket : {},
    
    launch : function () {
        // Connect to server
        var ioClient = require('socket.io-client')
        self.socket = ioClient.connect( 'http://localhost:' + '8979'/*agentConfig.config.port*/, {reconnect: true});


       //Identify
        self.socket.on('connect', function () {
            console.log('Connected!');
            self.socket.emit ( 'Identification',
                {   name : agentConfig.config.name,
                    id : agentConfig.config.id ,
                    version : agentConfig.config.version
                });
        });

        //Check Version & Status
        self.socket.on ( 'AgentCheckVersion' , function (){
            self.socket.emit ( 'AgentCheckVersionACK', { version : agentConfig.config.version })
        });

        self.socket.on ( 'AgentCheckStatus' , function (){
            self.socket.emit ( 'AgentCheckStatusACK');
        })

        //Update Configuration File
        self.socket.on ('AgentReloadConfig', function ( operationId ){
            agentConfig.configReload ( "./tmp_agentConfigFile.json" , function ( valid ){
                if ( valid ){
                    self.socket.emit ( 'AgentConfigReloadACK',
                        {   name : agentConfig.config.name,
                            id : agentConfig.config.id ,
                            operationId : operationId
                        });
                }else{
                    //socket.emit ( 'ConfigReloadACK', { 'component': 'Router', operationId : operationId });
                }
            });
        });

        self.socket.on ( 'AgentMsgFromIot' ,  function (data, callback ){
            //TODO
        });
    },
    
    sendDataToIot : function (data){
        self.socket.emit ( 'AgentMsgToIot' , data );
    }
}
